exports = module.exports = function logger(options) {

  return function logger(req, res, next) {
    var status = res.statusCode
      , statusColor;

    req._start = new Date();

    if (status >= 500) {
      statusColor = 'red';
    } else if (status >= 400) {
      statusColor = 'yellow';
    } else {
      statusColor = 'green';
    }

    function log() {
      res.removeListener('finish', log);
      res.removeListener('close', log);
      process.stdout.write((req.method + ' ').grey
                         + (req.url + ' ')
                         + (status + ' ')[statusColor]
                         + ((new Date() - req._start) + 'ms ').grey
                         + '\n');
    }

    res.on('finish', log);
    res.on('close', log);
    next();
  };
};